#ifndef __GRAPH_H__
#define __GRAPH_H__

#include "util.h"

extern string strPath;

class CGraph {
public:
	CGraph(map<string, string> &mConf, int nWidth, int nHeight, const vector<string> &vLabel, const vector<int> &vData);
	~CGraph();
	virtual void OnDraw(HDC hdc) = 0;
	virtual void OnUpdate(void) {}
	
	static CGraph *CreateGraph(map<string, string> &mConf, const vector<string> &vLabel, const vector<int> &vData);
	
	static HWND m_hWnd;
	
protected:
	void DrawBackground(HDC hdc);
	
	int m_nWidth, m_nHeight;
	string m_strTitle;
	HBITMAP m_hbmpBackground;
	HBITMAP m_ahbmpMarkImage[3];
	HBITMAP m_ahbmpMarkMask[3];
	COLORREF m_cBackground;
	COLORREF m_cFrame;
	COLORREF m_cLine;
	COLORREF m_cFont;
	int      m_nFrameWidth;
	int      m_nLineWidth;
	vector<string> m_vLabel;
	vector<int>    m_vData;
};

// ܂Ot
class CLineGraph : public CGraph {
public:
	CLineGraph(map<string, string> &mConf, const vector<string> &vLabel, const vector<int> &vData);
	~CLineGraph();
	void OnDraw(HDC hdc);
};

// c_Ot
class CVBarGraph : public CGraph {
public:
	CVBarGraph(map<string, string> &mConf, const vector<string> &vLabel, const vector<int> &vData);
	~CVBarGraph();
	void OnDraw(HDC hdc);
protected:
	int m_nBarWidth;
	COLORREF m_cBar;
};

// ɂ܂ԃOt
class CUseTimeGraph : public CLineGraph {
	int m_nMaxNum;

	void UpdateUseTime(void);

public:
	CUseTimeGraph(map<string, string> &mConf);
	~CUseTimeGraph();
	void OnUpdate(void);
};

// [_[`[g
class CRadarChart : public CGraph {
public:
	CRadarChart(map<string, string> &mConf, const vector<string> &vLabel, const vector<int> &vData);
	~CRadarChart();
	void OnDraw(HDC hdc);
	virtual void OnDrawFrame(HDC hdc);
};

// [_[`[gAIOt
class CAIGraph : public CRadarChart {
public:
	CAIGraph(map<string, string> &mConf, const vector<string> &vLabel, const vector<int> &vData);
	~CAIGraph();
	void OnDrawFrame(HDC hdc);
};

#endif //__GRAPH_H__
