#include "util.h"

#pragma comment(lib, "zlib.lib")
#pragma comment(lib, "libpng.lib")

#include "png.h"

extern HINSTANCE hInst;

//---------------------------------------------------------------------------
// ؂蕪
void SplitString(char *szString, const char *szDelimiter, vector<char*> &vDest) {
	int nDelimLength = strlen(szDelimiter);
	while (true) {
		vDest.push_back(szString);
		szString = strstr(szString, szDelimiter);
		if (!szString)
			break;
		*szString = '\0';
		szString += nDelimLength;
	}
}

//---------------------------------------------------------------------------
// l𕶎ɕϊ
string ToStr(int val) {
	char buf[32];
	_itoa(val, buf, 10);
	return buf;
}

//---------------------------------------------------------------------------
// u
void ReplaceString(string &str, const char *szFind, const char *szReplace) {
	string buf;
	int pos = 0, fndlen = strlen(szFind);
	
	while (char *tmp = strstr(str.c_str() + pos, szFind)) {
		buf.append(str, pos, tmp - (str.c_str() + pos));
		buf.append(szReplace);
		pos = tmp - str.c_str() + fndlen;
	}
	buf.append(str, pos, string::npos);
	str = buf;
}

//---------------------------------------------------------------------------
// [̋󔒕菜
string &Trim(string &str) {
	UINT nFirst = 0, nLast = str.length();
	while (true) {
		nFirst = str.find_first_not_of(" \t", nFirst);
		if (nFirst == string::npos)
			return str = "";
		if (str[nFirst] == "@"[0] && str[nFirst + 1] == "@"[1])
			nFirst += 2;
		else
			break;
	}
	while (true) {
		nLast = str.find_last_not_of(" \t", nLast);
		if (nLast >= 1 && str[nLast - 1] == "@"[0] && str[nLast] == "@"[1])
			nLast -= 2;
		else
			break;
	}
	if (nFirst == 0 && nLast == str.length())
		return str;
	str.erase(nLast + 1);
	str.erase(0, nFirst);
	return str;
}

//---------------------------------------------------------------------------
// J}؂ŃGg񋓂Ăt@Cǂݍ
bool GetEntries(const string &strFilename, map<string, string> &mEntries) {
	mEntries.clear();
	FILE *f = fopen(strFilename.c_str(), "r");
	if (!f)
		return false;
	char szTmp[512];
	while (!feof(f)) {
		fgets(szTmp, sizeof szTmp, f);
		int nLen = strlen(szTmp);
		if (strncmp(szTmp, "//", 2) == 0)
			continue;
		if (szTmp[nLen - 1] == '\n')
			szTmp[nLen - 1] = '\0';
		char *p = strchr(szTmp, ',');
		if (!p)
			continue;
		*p++ = '\0';
		mEntries.insert(map<string, string>::value_type(szTmp, p));
	}
	fclose(f);
	return true;
}

void fgetline(char *szBuffer, int nLength, FILE *f) {
	while (!feof(f)) {
		fgets(szBuffer, nLength, f);
		int nLen = strlen(szBuffer);
		if (szBuffer[nLen - 1] == '\n')
			szBuffer[--nLen] = '\0';
		string strTmp = szBuffer;
		Trim(strTmp);
		if (!strTmp.empty()) {
			strcpy(szBuffer, strTmp.c_str());
			return;
		}
	}
}

//---------------------------------------------------------------------------
// J؂ŃGg񋓂Ăt@Cǂݍ
// Քn`Aumeici`AINI`ɑΉ
bool GetNestingEntries(const string &strFilename, map<string, map<string, string> > &mEntries, const string &strDef) {
	FILE *f = fopen(strFilename.c_str(), "r");
	if (!f)
		return false;
	char szTmp[512];
	map<string, string> *pEntries = NULL;
	map<string, string> &mDefEntries = mEntries[strDef];
	while (!feof(f)) {
		fgetline(szTmp, sizeof szTmp, f);
		int nLen = strlen(szTmp);
		
		// [O[v] `
		if (szTmp[0] == '[' && szTmp[nLen - 1] == ']') {
			pEntries = &mEntries[string(szTmp + 1, nLen - 2)];
			continue;
		}
		if (strncmp(szTmp, "//", 2) == 0)
			continue;
		char *pSep = min(strchr(szTmp, ',') - 1, strchr(szTmp, '=') - 1) + 1;
		
		if (!pEntries) {
			// GgO[vO
			if (pSep) {
				// ftHgO[vɃGgǉ 
				*pSep++ = '\0';
				string strKey = szTmp, strVal = pSep;
				mDefEntries.insert(map<string, string>::value_type(Trim(strKey), Trim(strVal)));
			} else {
				// GgO[vJn
				pEntries = &mEntries[szTmp];
			}
		} else {
			// GgO[v
			if (strcmp(szTmp, "{") == 0) {
			} else if (strcmp(szTmp, "}") == 0) {
				// GgO[vI
				pEntries = NULL;
			} else if (pSep) {
				// Ggǉ
				*pSep++ = '\0';
				string strKey = szTmp, strVal = pSep;
				pEntries->insert(map<string, string>::value_type(Trim(strKey), Trim(strVal)));
			} else {
				// ʃGgO[vJn
				pEntries = &mEntries[szTmp];
			}
		}
	}
	fclose(f);
	return true;
}

//---------------------------------------------------------------------------
// LoadPngpt@Cǂݍ݃vV[W
void PngReadProc(png_structp png_ptr, png_bytep data, png_size_t length) {
	ReadFile(png_get_io_ptr(png_ptr), data, length, (DWORD*)&length, NULL);
}

//---------------------------------------------------------------------------
// LoadPngp4F`16F`ϊ֐
void to4bpp(png_structp png_ptr, png_row_infop row_info, png_bytep data) {
	static const png_byte pix[] = {
		0x00, 0x01, 0x02, 0x03, 0x10, 0x11, 0x12, 0x13,
			0x20, 0x21, 0x22, 0x23, 0x30, 0x31, 0x32, 0x33,
	};
	png_uint_32 rowb;
	png_byte *p, *q, c;
	
	rowb = (row_info->width + 1) / 2;
	q = data + rowb;
	p = data + rowb / 2;
	
	if (rowb % 2 == 1) {
		c = *p;
		*(--q) = pix[c >> 4];
	}
	while (p > data) {
		c = *(--p);
		*(--q) = pix[c & 0x0f];
		*(--q) = pix[c >> 4];
	}
	row_info->bit_depth   = 4;
	row_info->pixel_depth = 4;
	row_info->rowbytes    = rowb;
}


//---------------------------------------------------------------------------
// PNGt@Cǂݍ
HBITMAP LoadPng(const string &strFilename) {
	HANDLE hFile = CreateFile(strFilename.c_str(), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return NULL;
	
	// PNGǂݍ݊Jn
	png_struct *png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if (!png_ptr) {
		CloseHandle(hFile);
		return NULL;
	}
	
	png_info *info_ptr = png_create_info_struct(png_ptr);
	if (!info_ptr) {
		png_destroy_read_struct(&png_ptr, NULL, NULL);
		CloseHandle(hFile);
		return NULL;
	}
	/*png_info *end_info = png_create_info_struct(png_ptr);
	if (!end_info) {
    png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
    CloseHandle(hFile);
    return NULL;
}*/
	
	png_set_read_fn(png_ptr, hFile, PngReadProc);
	png_uint_32 nWidth, nHeight;
	int nDepth, nPal;
	int nPngDepth, nColorType, nInterlaceType, nCompType, nFilterType;
	
	png_read_info(png_ptr, info_ptr);
	png_get_IHDR(png_ptr, info_ptr, &nWidth, &nHeight, &nPngDepth, &nColorType, &nInterlaceType, &nCompType, &nFilterType);
	
	if (nColorType == PNG_COLOR_TYPE_RGB || nColorType == PNG_COLOR_TYPE_RGB_ALPHA) {
		nPngDepth = 24;
		nDepth = 24;
		nPal = 0;
	} else {
		switch (nPngDepth) {
		case 2:  nDepth = 4; break;
		case 16: nDepth = 8; break;
		default: nDepth = nPngDepth; break;
		}
		nPal = 1 << nDepth;
	}
	
	if (nColorType & PNG_COLOR_MASK_ALPHA)
		png_set_strip_alpha(png_ptr);
	if (nPngDepth == 2)
		png_set_read_user_transform_fn(png_ptr, to4bpp);
	else if (nPngDepth == 16)
		png_set_strip_16(png_ptr);
	if (nColorType== PNG_COLOR_TYPE_RGB || nColorType == PNG_COLOR_TYPE_RGB_ALPHA)
		png_set_bgr(png_ptr);
	png_read_update_info(png_ptr, info_ptr);
	
	int nRowBytes = (nWidth * nDepth + 31) / 32 * 4;
	int nImgBytes = nRowBytes * nHeight;
	BITMAPINFO* bi = (BITMAPINFO*)GlobalAlloc(GMEM_FIXED, sizeof BITMAPINFOHEADER + nPal * sizeof RGBQUAD);
	
	if (nPal > 0) {
		vector<png_color> vPalette;
		vPalette.resize(nPal);
		if (nColorType == PNG_COLOR_TYPE_PALETTE) {
			png_color *palette;
			int num_palette;
			png_get_PLTE(png_ptr, info_ptr, &palette, &num_palette);
			if (num_palette > nPal)
				num_palette = nPal;
			memset(vPalette.begin(),       0, nPal * sizeof png_color);
			memcpy(vPalette.begin(), palette, num_palette * sizeof png_color);
		} else {
			int depth = nPngDepth == 16 ? 8 : nPngDepth;
			png_build_grayscale_palette(depth, vPalette.begin());
		}
		
		for (int i = 0; i < nPal; ++i) {
			bi->bmiColors[i].rgbRed   = vPalette[i].red;
			bi->bmiColors[i].rgbGreen = vPalette[i].green;
			bi->bmiColors[i].rgbBlue  = vPalette[i].blue;
		}
	}
	
	memset(bi, 0, sizeof BITMAPINFOHEADER);
	bi->bmiHeader.biSize        = sizeof BITMAPINFOHEADER;
	bi->bmiHeader.biWidth       = nWidth;
	bi->bmiHeader.biHeight      = nHeight;
	bi->bmiHeader.biPlanes      = 1;
	bi->bmiHeader.biBitCount    = nDepth;
	bi->bmiHeader.biCompression = BI_RGB;
	bi->bmiHeader.biSizeImage   = nImgBytes;
	bi->bmiHeader.biClrUsed     = nPal;
	
	HDC hdc = GetDC(NULL);
	BYTE *pBits;
	HBITMAP hBitmap = CreateDIBSection(hdc, bi, DIB_RGB_COLORS, (void**)&pBits, NULL, 0);
	if (!pBits) {
		png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
		return NULL;
	}
	ReleaseDC(NULL, hdc);
	GlobalFree(bi);
	
	vector<BYTE*> vRowPtr;
	vRowPtr.reserve(nHeight);
	for (int y = (nHeight - 1); y >= 0; --y)
		vRowPtr.push_back(pBits + y * nRowBytes);
	
	png_read_image(png_ptr, vRowPtr.begin());
	//png_read_end(png_ptr, end_info);
	png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
	
	CloseHandle(hFile);
	
	return hBitmap;
}

//---------------------------------------------------------------------------
// }XN摜iTrans=White, Copy=Blackj쐬
HBITMAP MakeMaskBitmap(HBITMAP &hBitmap) {
	if (!hBitmap)
		return NULL;
	
	BITMAP bm;
	GetObject(hBitmap, sizeof bm, &bm);
	
	BITMAPINFO bmi = { sizeof BITMAPINFOHEADER };
	bmi.bmiHeader.biWidth = bm.bmWidth;
	bmi.bmiHeader.biHeight = -bm.bmHeight;
	bmi.bmiHeader.biBitCount = 24;
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biSizeImage = bm.bmWidth * bm.bmHeight * 3;
	
	// HDCp
	HDC hdc = CreateCompatibleDC(NULL);
	HDC hdcWrk = CreateCompatibleDC(NULL);
	
	// Image쐬
	// HBITMAPp
	BYTE *pBuffer;
	HBITMAP hBmpImage = CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (void**)&pBuffer, NULL, 0);
	GetObject(hBmpImage, sizeof bm, &bm);
	int nWidthBytes = (bm.bmWidthBytes + 3) & ~3;
	// HBITMAPZbg
	HBITMAP hBmpOld = (HBITMAP)SelectObject(hdc, hBitmap);
	HBITMAP hBmpWrkOld = (HBITMAP)SelectObject(hdcWrk, hBmpImage);
	// ]
	BitBlt(hdcWrk, 0, 0, bm.bmWidth, bm.bmHeight, hdc, 0, 0, SRCCOPY);
	
	COLORREF cTrans = *(DWORD*)pBuffer & 0xffffff;
	for (int y = 0; y < bm.bmHeight; ++y) {
		for (int x = 0; x < bm.bmWidth; ++x) {
			DWORD *p = (DWORD*)(pBuffer + (x * 3 + y * nWidthBytes));
			// ߐF𔒂
			if ((*p & 0xffffff) == cTrans)
				*p = *p & ~0xffffff | 0xffffff;
		}
	}
	
	// Mask쐬
	// HBITMAPp
	HBITMAP hBmpMask = CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, (void**)&pBuffer, NULL, 0);
	GetObject(hBmpMask, sizeof bm, &bm);
	nWidthBytes = (bm.bmWidthBytes + 3) & ~3;
	// HBITMAPZbg
	SelectObject(hdcWrk, hBmpMask);
	// ]
	BitBlt(hdcWrk, 0, 0, bm.bmWidth, bm.bmHeight, hdc, 0, 0, SRCCOPY);
	
	for (int y = 0; y < bm.bmHeight; ++y) {
		for (int x = 0; x < bm.bmWidth; ++x) {
			DWORD *p = (DWORD*)(pBuffer + (x * 3 + y * nWidthBytes));
			// ߐF𔒂ɁAȊO
			if ((*p & 0xffffff) != cTrans)
				*p = *p & ~0xffffff | 0x000000;
			else
				*p = *p & ~0xffffff | 0xffffff;
		}
	}
	
	// ]j
	SelectObject(hdc, hBmpOld);
	DeleteDC(hdc);
	
	// ]j
	SelectObject(hdcWrk, hBmpWrkOld);
	DeleteDC(hdcWrk);
	
	hBitmap = hBmpImage;
	return hBmpMask;
}


COLORREF GetColor(map<string, string> &m, const string &s, COLORREF cDef) {
	if (m.count(s)) {
		DWORD dwColoreRev =  strtoul(m[s].c_str(), NULL, 16);
		return (dwColoreRev & 0xff0000) >> 16 | (dwColoreRev & 0xff00) | (dwColoreRev & 0xff) << 16;
	} if (m.count(s + ".r") || m.count(s + ".g") || m.count(s + ".b"))
		return RGB(atoi(m[s + ".r"].c_str()), atoi(m[s + ".g"].c_str()), atoi(m[s + ".b"].c_str()));
	return cDef;
}

int GetNumber(map<string, string> &m, const string &s, int nDef) {
	if (m.count(s)) {
		const char *pStart = m[s].c_str();
		char *pEnd;
		int n = strtoul(pStart, &pEnd, 10);
		if (pStart != pEnd)
			return n;
	}
	return nDef;
}

HBITMAP LoadImageEx(const string &strFilename) {
	if (strFilename.empty())
		return NULL;
	if (HBITMAP hBmp = (HBITMAP)LoadImage(hInst, strFilename.c_str(), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE))
		return hBmp;
	return LoadPng(strFilename);
}
